#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

struct DSU {
    vector<int> p, sz;
    DSU(int n) {
        p.resize(n + 1);
        sz.resize(n + 1, 1);
        for (int i = 1; i <= n; i++) {
            p[i] = i;
        }
    }
    int find(int v) {
        return (p[v] == v ? v : p[v] = find(p[v]));
    }
    void merge(int a, int b) {
        a = find(a), b = find(b);
        if (a == b) {
            return;
        }
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        p[b] = a;
        sz[a] += sz[b];
    }
};

const int N = 1e5 + 10;
int kek[N];
vector<pair<int, int>> edge;
vector<pair<int, int>> upd[N];
vector<int> check[N], have[N];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        edge.pb({u, v});
    }
    for (int i = 0; i < k; i++) {
        int u, v;
        cin >> u >> v;
        upd[0].pb({u, v});
    }
    int q;
    cin >> q;
    vector<pair<int, int>> que;
    for (int i = 1; i <= q; i++) {
        char type;
        cin >> type;
        if (type == 'T') {
            int u, v;
            cin >> u >> v;
            upd[i].pb({u, v});
        }
        else if (type == 'F') {
            int u, v;
            cin >> u >> v;
            edge.pb({u, v});
            kek[SZ(edge) - 1] = i;
        }
        else {
            int v;
            cin >> v;
            que.pb({v, i});
        }
    }
    int M = SZ(edge);
    vector<int> L(M), R(M, q + 1);
    for (int i = 0; i < M; i++) {
        L[i] = kek[i] - 1;
    }
    for (int iter = 0; iter < 20; iter++) {
        for (int i = 0; i <= q; i++) {
            check[i] = {};
        }
        for (int i = 0; i < M; i++) {
            if (R[i] - L[i] <= 1) {
                continue;
            }
            check[(L[i] + R[i]) / 2].pb(i);
        }
        DSU G(n + 1);
        for (int i = 0; i <= q; i++) {
            for (auto it : upd[i]) {
                G.merge(it.F, it.S);
            }
            for (auto it : check[i]) {
                if (G.find(edge[it].F) == G.find(edge[it].S)) {
                    R[it] = (L[it] + R[it]) / 2;
                }
                else {
                    L[it] = (L[it] + R[it]) / 2;
                }
            }
        }
    }
    for (int i = 0; i < M; i++) {
        have[edge[i].F].pb(R[i]);
        have[edge[i].S].pb(R[i]);
    }
    for (int i = 1; i <= n; i++) {
        sort(all(have[i]));
    }
    for (auto it : que) {
        int v = it.F, time = it.S;
        cout << upper_bound(all(have[v]), time) - have[v].begin() << '\n';
    }
}
