#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <cstring>
#include <random>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()

using namespace std;
typedef long long ll;


vector<int> sz;
vector<int> p;

int mod = 1e9 + 7;

struct otk {
    int a, pa, sa;
};


int findp(int a) {
    if(p[a] == a)
        return a;
    return findp(p[a]);
}

bool merge(int a, int b) {
    a = findp(a), b = findp(b);
    if(sz[a] < sz[b])
        swap(a, b);
    if(a == b)
        return 1;
    p[b] = a;
    sz[a] += sz[b];
    return 0;
}

bool merge2(int a, int b, vector<otk>& was) {
    a = findp(a), b = findp(b);
    if(sz[a] < sz[b])
        swap(a, b);
    if(a == b)
        return 1;
    was.pb({a, p[a], sz[a]});
    was.pb({b, p[b], sz[b]});
    p[b] = a;
    sz[a] += sz[b];
    return 0;
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    p = vector<int> (n + 1);
    sz = vector<int> (n + 1);
    for (int i = 0; i < n; i++) {
        p[i] = i, sz[i] = 1;
    }
    vector<bool> ans(n, 1);
    vector<int> fs;
    int k = 500;

    for (int i = 0; i < n; i++) {
        cin >> a[i];
        fs.pb(a[i]);
    }
    sort(fs.begin(), fs.end());
    map<int, int> num;
    int cnt = 0;
    for (auto x : fs) {
        if(num.count(x))
            continue;
        num[x] = cnt++;
    }

    for (int i = 0; i < n; i++)
        b[i] = num[a[i]];

    vector<pair<int, int>> reb;
    for (int i = 1; i < n; i += 2) {
        if(i + 1 >= n)
            break;
        int v1 = b[i], u1 = b[i + 1];
        reb.pb({v1, u1});
    }

    vector<vector<pair<pair<int, int>, int>>> bloks(n / k + 10);
    for (int i = 0; i < n; i += 2) {
        int l = i / 2, r = (i + 2 * (a[i] - 1)) / 2;
        if(a[i] == 0) {
            ans[i] = 1;
            continue;
        }
        if(r >= len(reb)) {
            ans[i] = 0;
            continue;
        }
        if(r / k == l / k) {
            vector<otk> was;
            bool flag2 = 0;
            for (int t = l; t <= r; t++) {
                if(merge2(reb[t].ft, reb[t].sc, was))
                    flag2 = 1;
            }
            if(!flag2)
                ans[i] = 1;
            else
                ans[i] = 0;
            reverse(was.begin(), was.end());
            for (auto x : was) {
                p[x.a] = x.pa;
                sz[x.a] = x.sa;
            }
            continue;
        }
        bloks[l / k].pb({{r, l}, i});
    }
    for (int i = 0; i < n / k + 10; i++) {
        if(bloks[i].size() == 0)
            continue;
        sort(bloks[i].begin(), bloks[i].end());
        for (auto& x : bloks[i]) {
            swap(x.ft.ft, x.ft.sc);
        }
        for (int i = 0; i < n; i++) {
            sz[i] = 1, p[i] = i;
        }
        int r = i * k + k;
        bool flag = 0;
        for (int j = 0; j < len(bloks[i]); j++) {
            if(flag == 1) {
                ans[bloks[i][j].sc] = 0;
                continue;
            }
            while(r <= bloks[i][j].ft.sc) {
                if(merge(reb[r].ft, reb[r].sc))
                    flag = 1;
                r++;
            }
            bool flag2 = 0;
            vector<otk> was;
            for (int t = i * k + k - 1; t >= bloks[i][j].ft.ft; t--) {
                if(merge2(reb[t].ft, reb[t].sc, was))
                    flag2 = 1;
            }
            if(!flag2 && !flag)
                ans[bloks[i][j].sc] = 1;
            else
                ans[bloks[i][j].sc] = 0;
            reverse(was.begin(), was.end());
            for (auto x : was) {
                p[x.a] = x.pa;
                sz[x.a] = x.sa;
            }
        }
        bloks[i].clear();
    }
    reb.clear();
    for (int i = 0; i < n; i++) {
        sz[i] = 1, p[i] = i;
    }
    for (int i = 2; i < n; i += 2) {
        if(i + 1 >= n)
            break;
        int v1 = b[i], u1 = b[i + 1];
        reb.pb({v1, u1});
    }


    for (int i = 1; i < n; i += 2) {
        int l = i / 2, r = ((i - 1) + 2 * (a[i] - 1)) / 2;
        if(a[i] == 0) {
            ans[i] = 1;
            continue;
        }
        if(r >= len(reb)) {
            ans[i] = 0;
            continue;
        }
        if(r / k == l / k) {
            vector<otk> was;
            bool flag2 = 0;
            for (int t = l; t <= r; t++) {
                if(merge2(reb[t].ft, reb[t].sc, was))
                    flag2 = 1;
            }
            if(!flag2)
                ans[i] = 1;
            else
                ans[i] = 0;
            reverse(was.begin(), was.end());
            for (auto x : was) {
                p[x.a] = x.pa;
                sz[x.a] = x.sa;
            }
            continue;
        }
        bloks[l / k].pb({{r, l}, i});
    }
    for (int i = 0; i < n / k + 10; i++) {
        if(bloks[i].size() == 0)
            continue;
        sort(bloks[i].begin(), bloks[i].end());
        for (auto& x : bloks[i]) {
            swap(x.ft.ft, x.ft.sc);
        }
        for (int i = 0; i < n; i++) {
            sz[i] = 1, p[i] = i;
        }
        int r = i * k + k;
        bool flag = 0;
        for (int j = 0; j < len(bloks[i]); j++) {
            if(flag == 1) {
                ans[bloks[i][j].sc] = 0;
                continue;
            }
            while(r <= bloks[i][j].ft.sc) {
                if(merge(reb[r].ft, reb[r].sc))
                    flag = 1;
                r++;
            }
            bool flag2 = 0;
            vector<otk> was;
            for (int t = i * k + k - 1; t >= bloks[i][j].ft.ft; t--) {
                if(merge2(reb[t].ft, reb[t].sc, was))
                    flag2 = 1;
            }
            if(!flag2 && !flag)
                ans[bloks[i][j].sc] = 1;
            else
                ans[bloks[i][j].sc] = 0;
            reverse(was.begin(), was.end());
            for (auto x : was) {
                p[x.a] = x.pa;
                sz[x.a] = x.sa;
            }
        }
        bloks[i].clear();
    }

    vector<int> dp(n + 1, 0);
    ll ANS = 0;
    for (int i = n - 1; i >= 0; i--) {
        if(ans[i] == 0)
            continue;
        dp[i] = 1;
        int r = i + 2 * a[i] + 1;
        if(r < n)
            dp[i] += dp[r];
        ANS += dp[i];
    }
    cout << ANS << endl;

}
