#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define ll long long

using namespace std;

template <class T = int>
T next() { T x; cin >> x; return x; }

inline int to_mass(int s, int m, vector<int> &arr)
{
	int sum = 0;

	for (int i = 0; i < 32; i++)
	{
		if (s & (1 << i))
		{
			sum += arr[i];
		}
	}

	return sum % m;
}

int main()
{
	int n = next(), m = next();
	vector<int> arr(n);
	set<int> tmp;

	for (int i = 0; i < n; i++)
	{
		int x = next() % m;
		arr[i] = x;
		tmp.insert(x);
	}

	if (tmp.size() < n)
	{
		for (int i = 0; i < n; i++)
		{
			for (int j = i + 1; j < n; j++)
			{
				if (arr[i] == arr[j])
					cout << "1\n" << i + 1 << "\n" << "1\n" << j + 1 << '\n';
			}
		}

		return 0;
	}

	vector<vector<int>> mask(m);

	for (int s = 0; s < (1 << n); s++)
	{
		int mass = to_mass(s, m, arr);
		
		for (int s_old : mask[mass])
		{
			if ((s & s_old) == 0)
			{
				vector<int> a, b;

				for (int i = 0; i < 32; i++)
				{
					if (s & (1 << i))
						a.push_back(i + 1);
					if (s_old & (1 << i))
						b.push_back(i + 1);
				}

				cout << a.size() << '\n';
				for (int i : a) cout << i << ' ';
				cout << '\n' << b.size() << '\n';
				for (int i : b) cout << i << ' ';

				return 0;
			}
		}

		mask[mass].push_back(s);
	}

	cout << "-1\n";
	return 0;
}