//package olymp;

import java.util.LinkedList;
import java.util.Scanner;

public class C {

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);

        int n = s.nextInt();
        int m = s.nextInt();
        int k = s.nextInt();

        Town[] towns = new Town[n];
        for (int i = 0; i < n; i++) towns[i] = new Town();

        for (int i = 0; i < m; i++)
            push("F", s.nextInt() - 1, s.nextInt() - 1, towns);

        for (int i = 0; i < k; i++)
            push("T", s.nextInt() - 1, s.nextInt() - 1, towns);

        int q = s.nextInt();
        for (int i = 0; i < q; i++) {
            String fun = s.next();
            push(fun, s.nextInt() - 1, (fun.equals("?")) ? 0 : s.nextInt() - 1, towns);
        }
    }

    private static void push(String fun, int a, int b, Town[] towns) {
        switch (fun) {
            case "T":
                towns[a].paths.add(b);
                towns[b].paths.add(a);
                break;
            case "F":
                towns[a].friends.add(b);
                towns[b].friends.add(a);
                break;
            case "?":
                System.out.println(guests(towns, a));
                break;
        }
    }

    static class Town {
        LinkedList<Integer> friends = new LinkedList<>();
        LinkedList<Integer> paths = new LinkedList<>();

        @Override
        public String toString() {
            return friends + " " + paths;
        }
    }

    private static int guests(Town[] towns, int i) {
        int sum = 0;
        Town my = towns[i];

        boolean[] was = new boolean[towns.length];

        LinkedList<Town> queue = new LinkedList<>();
        queue.add(my);
        while (!queue.isEmpty()) {
            Town cur = queue.removeFirst();

            for (int j = 0; j < cur.paths.size(); j++) {
                int tf = cur.paths.get(j);

                if (!was[tf]) {
                    was[tf] = true;

                    queue.add(towns[tf]);
                    for (int k = 0; k < towns[tf].paths.size(); k++)
                        queue.add(towns[towns[tf].paths.get(k)]);

                    if (my.friends.indexOf(tf) != -1)
                        sum++;
                }
            }
        }

        return sum;
    }
}