def read_ints():
    return [int(x) for x in input().split()]

def add_edge_friendship(g, x, y):
    g[x].append(y)
    g[y].append(x)

def add_edge_races(g, x, y):
    g[x].append(y)
    g[y].append(x)

def read_command():
    i = input().split()
    if len(i) < 3: return i[0], int(i[1]), None
    else: return i[0], int(i[1]), int(i[2])

def fill_buckets_dst(races, buckets, v, vst, n):
    if vst[v]: return
    vst[v] = True
    buckets[v] = n
    for w in races[v]: fill_buckets_dst(races, buckets, w, vst, n)

def fill_buckets(races, buckets):
    n = 0
    vst = [False for i in races]
    for v in range(len(races)):
        if not vst[v]:
            fill_buckets_dst(races, buckets, v, vst, n)
            n += 1

def reach_amount(target, buckets, friendship):
    n = 0
    for v in friendship[target]:
        if buckets[target] == buckets[v]: n += 1
    return n

def process_add(buckets, a, b):
    x = buckets[a]
    y = buckets[b]
    if x != y:
        for i in range(len(buckets)):
            if buckets[i] == y: buckets[i] = x

n, m, k = read_ints()
friendship = [[] for j in range(n)]
races = [[] for j in range(n)]
buckets = [None for i in range(n)]

for i in range(m):
    a, b = read_ints()
    add_edge_friendship(friendship, a-1, b-1)
for i in range(k):
    a, b = read_ints()
    add_edge_races(races, a-1, b-1)
fill_buckets(races, buckets)

q = int(input())
for i in range(q):
    cmd, arg1, arg2 = read_command()
    if cmd == "T": process_add(buckets, arg1-1, arg2-1)
    elif cmd == "F": add_edge_friendship(friendship, arg1-1, arg2-1)
    elif cmd == "?": print(reach_amount(arg1-1, buckets, friendship))