#include <iostream>
#include <vector>
#include <map>
#include <set>

#define int long long
using namespace std;

int k[3];

int getDist(int lineId, int v, int u) {
    return k[lineId] * abs(v - u);
}

int d;
const int VERT = 20;
const int V1 = 15;
const int V2 = 16;
vector<pair<int, int>> g[VERT];

vector<vector<int>> per = {{1, 5},
                           {0, 2},
                           {3, 4}};
map<int, int> nOnLine;

const int INF = 8e18;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int x, y, z;
    cin >> x >> y >> z;
    int a, b, c;
    cin >> a >> b >> c;
    cin >> k[0] >> k[1] >> k[2];
    cin >> d;

    nOnLine[1] = a;
    nOnLine[5] = a + 1;
    nOnLine[0] = b + 1;
    nOnLine[2] = b;
    nOnLine[3] = c + 1;
    nOnLine[4] = c;
    for (int i = 0; i < 3; ++i) {
        g[2 * i + 0].push_back({2 * i + 1, d});
        g[2 * i + 1].push_back({2 * i + 0, d});
    }
    g[1].push_back({5, k[0]});
    g[5].push_back({1, k[0]});
    g[0].push_back({2, k[1]});
    g[2].push_back({0, k[1]});
    g[4].push_back({3, k[2]});
    g[3].push_back({4, k[2]});

    int lineV, v, lineU, u;
    cin >> lineV >> v >> lineU >> u;
    lineV--, lineU--;
    for (int m : per[lineV]) {
        g[V1].push_back({m, getDist(lineV, nOnLine[m], v)});
        g[m].push_back({V1, getDist(lineV, nOnLine[m], v)});
    }


    for (int m : per[lineU]) {
        g[V2].push_back({m, getDist(lineU, nOnLine[m], u)});
        g[m].push_back({V2, getDist(lineU, nOnLine[m], u)});
    }
    if (lineU == 0 ) {
        if (u == a) {
            g[0].push_back({1, 0});
            g[1].push_back({0, 0});
        }
        if (u == a + 1) {
            g[4].push_back({4, 0});
            g[5].push_back({5, 0});
        }
    }
    if (lineU == 1) {
        if (u == b + 1) {
            g[0].push_back({1, 0});
            g[1].push_back({0, 0});
        }
        if (u == b ) {
            g[2].push_back({3, 0});
            g[3].push_back({2, 0});
        }
    }

    if (lineU == 2) {
        if (u == c + 1) {
            g[2].push_back({3, 0});
            g[3].push_back({2, 0});
        }
        if (u == c) {
            g[4].push_back({5, 0});
            g[5].push_back({4, 0});
        }
    }
    if (lineV == 0 ) {
        if (v == a) {
            g[0].push_back({1, 0});
            g[1].push_back({0, 0});
        }
        if (v == a + 1) {
            g[4].push_back({4, 0});
            g[5].push_back({5, 0});
        }
    }
    if (lineV == 1) {
        if (v == b + 1) {
            g[0].push_back({1, 0});
            g[1].push_back({0, 0});
        }
        if (v == b ) {
            g[2].push_back({3, 0});
            g[3].push_back({2, 0});
        }
    }

    if (lineV == 2) {
        if (v == c + 1) {
            g[2].push_back({3, 0});
            g[3].push_back({2, 0});
        }
        if (v == c) {
            g[4].push_back({5, 0});
            g[5].push_back({4, 0});
        }
    }

    int dist[VERT];
    fill(dist, dist + VERT, INF);
    dist[V1] = 0;
    bool used[VERT];
    fill(used, used + VERT, false);
    while (true) {
        int minV = -1;
        for (int i = 0; i < VERT; ++i) {
            if (used[i]) {
                continue;
            }
            if (minV == -1 || dist[i] < dist[minV]) {
                minV = i;
            }
        }
        if (minV == -1) {
            break;
        }
        used[minV] = true;
        for (auto &[u, c]:g[minV]) {
            int curD = dist[minV] + c;
            if (curD < dist[u]) {
                dist[u] = curD;
            }
        }
    }
   /* if (lineU == 0 && ((u == a + 1) || (u == a))) {
        dist[V2] = min(dist[V2], dist[1]);
        dist[V2] = min(dist[V2], dist[5]);
    }
    if (lineU == 1 && ((u == b + 1) || (u == b))) {
        dist[V2] = min(dist[V2], dist[0]);
        dist[V2] = min(dist[V2], dist[2]);
    }

    if (lineU == 2 && ((u == c + 1) || (u == c))) {
        dist[V2] = min(dist[V2], dist[3]);
        dist[V2] = min(dist[V2], dist[4]);
    }*/
    cout << dist[V2] << "\n";

    return 0;
}