#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_set>

using namespace std;

int N = 111111;
vector<int> p(N), h(N);

int get(int x) {
    return x == p[x] ? x : p[x] = get(p[x]);
}

void merge(int x, int y) {
    x = get(x);
    y = get(y);
    if (h[x] > h[y]) {
        p[y] = x;
        h[y]++;
    } else {
        p[x] = y;
        h[x]++;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }

    vector<unordered_set<int>> v(n, unordered_set<int>(n));
    vector<int> d(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        v[a].insert(b);
        v[b].insert(a);
    }
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        merge(a, b);
    }
    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        char ch;
        cin >> ch;
        if (ch == 'T') {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            merge(a, b);
        } else if (ch == 'F') {
            int a, b;
            cin >> a >> b;
            a--;
            b--;
            if (get(a) == get(b)) {
                d[a]++;
                d[b]++;
                continue;
            }
            v[a].insert(b);
            v[b].insert(a);
        } else{
            int a;
            cin >> a;
            a--;
            int cnt = 0;
            vector<int> qwe;
            for (int j : v[a]) {
                if (get(a) == get(j)) {
                    d[a]++;
                    d[j]++;
                    qwe.push_back(j);
                    //v[a].erase(j);
                    v[j].erase(a);
                }
            }
            for (int j = 0; j < qwe.size(); j++) {
                v[a].erase(qwe[j]);
            }
            cout << d[a] << '\n';
        }
    }

    return 0;
}
