#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int n, m, k, q, c = 0;
vector<vector<int>> fr;
vector<vector<int>> rds;
vector<int> color;

void dfs(int v) {
	color[v] = c;
	for (int i = 0; i < rds[v].size(); i++) {
		if (color[rds[v][i]] == 0) {
			dfs(rds[v][i]);
		}
	}
}

void input() {
	cin >> n >> m >> k;
	fr.resize(n);
	rds.resize(n);
	color.resize(n);
	int a, b;
	for (int i = 0; i < m; i++) {
		cin >> a >> b;
		fr[a - 1].push_back(b - 1);
		fr[b - 1].push_back(a - 1);
	}
	for (int i = 0; i < k; i++) {
		cin >> a >> b;
		rds[a - 1].push_back(b - 1);
		rds[b - 1].push_back(a - 1);
	}
	cin >> q;
}

int check(int v) {
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (color[i] == color[v] && find(fr[v].begin(), fr[v].end(), i) != fr[v].end()) {
			ans++;
		}
	}
	return ans;
}

void rerd(int a, int b) {
	int col = color[b - 1];
	for (int i = 0; i < n; i++) {
		
		if (col == color[i]) {
			color[i] = color[a - 1];
		}
	}
}

void questions() {
	char t;
	int a, b;
	for (int i = 0; i < q; i++) {
		cin >> t;
		switch (t) {
		case 'T':
			cin >> a >> b;
			rds[a - 1].push_back(b - 1);
			rds[b - 1].push_back(a - 1);
			rerd(a, b);
			break;
		case 'F':
			cin >> a >> b;
			fr[a - 1].push_back(b - 1);
			fr[b - 1].push_back(a - 1);
			break;
		case '?':
			cin >> a;
			cout << check(a - 1) << "\n";
		}
	}
}

int main() {
	ios::sync_with_stdio(false);

	input();
	for (int i = 0; i < n; i++) {
		if (color[i] == 0) {
			c++;
			dfs(i);
		}
	}
	questions();
}