//  Copyright 2019 Nikita Golikov

#include <bits/stdc++.h>

#define BITSET_ITER(i, bt) for (auto i = bt._Find_first(); i != bt.size();\
i = bt._Find_next(i))

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::queue;
using std::deque;
using std::stack;
using std::string;
using std::map;
using std::set;
using std::pair;
using std::tuple;
using std::unique_ptr;
using std::shared_ptr;
using std::unordered_map;
using std::unordered_set;
using std::multiset;
using std::sort;
using std::reverse;
using std::function;
using std::make_pair;
using std::make_tuple;
using i32 = std::int32_t;
using ui32 = std::uint32_t;
using i64 = std::int64_t;
using ui64 = std::uint64_t;

//#ifdef GOLIKOV
//std::mt19937 rng(566);
//#else
//std::mt19937 rng(static_cast<unsigned>(std::chrono::high_resolution_clock::now()
//.time_since_epoch().count()));
//#endif
//
//template <typename T>
//T rnd(T l, T r) {
//  if constexpr (std::is_integral_v<T>) {
//    return std::uniform_int_distribution<T>(l, r)(rng);
//  } else {
//    return std::uniform_real_distribution<T>(l, r)(rng);
//  }
//}
//
//template <typename T>
//auto make_vector() {
//  return T();
//}
//
//template <typename T, typename... Args>
//auto make_vector(size_t n, Args... args) {
//  return vector(n, make_vector<T>(args...));
//}
//
//template <typename... Args>
//void read(Args& ... args) {
//  (cin >> ... >> args);
//}
//
//constexpr bool golikov() {
//#ifdef GOLIKOV
//  return true;
//#else
//  return false;
//#endif
//}
//
//template <bool flush = false>
//void print() {
//  if constexpr (golikov() || flush) {
//    cout << std::endl;
//  } else {
//    cout << '\n';
//  }
//}
//
//template <bool flush = false, typename T, typename... Args>
//void print(T const& x, Args const& ... args) {
//  cout << x;
//  if constexpr (sizeof...(args)) {
//    cout << ' ';
//  }
//  print<flush>(args...);
//}

int check(vector<int> const& a, int m) {
  auto n = a.size();
  int pw = 1;
  for (int it = 0; it < n; ++it) {
    pw *= 3;
  }
  int cnt = 0;
  for (int mask = 1; mask < pw; ++mask) {
    int s = 0;
    int cur_mask = mask;
    for (auto x : a) {
      auto r = cur_mask % 3;
      if (r == 1) {
        s += x % m;
      } else if (r == 2) {
        s -= x % m;
      }
      s %= m;
      if (s < 0) {
        s += m;
      }
      cur_mask /= 3;
    }
    cnt += s == 0;
  }
  return cnt;
}

int main() {
//  if constexpr (golikov()) {
#ifdef GOLIKOV
    std::freopen("in", "rt", stdin);
#endif
//  }
  std::ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n;
  cin >> n;
  vector<int> a(n);
  auto solve = [](vector<int> a) -> pair<int, vector<int>> {
    int zeros = 0;
    int ones = 0;
    int minus = 0;
    for (auto& x : a) {
      zeros += x == 0;
      ones += x > 0;
      minus += x < 0;
    }
    auto n = a.size();
    assert(zeros + ones + minus == n);
    auto m = ((1 << n) - (1 << zeros));
    vector<int> ans(n);
    int pow = 1;
    int pow_non_zero = 1 << zeros;
    for (int i = 0; i < n; ++i) {
      if (a[i] == 0) {
        ans[i] = pow;
        pow *= 2;
      } else {
        if (a[i] > 0) {
          ans[i] = pow_non_zero;
        } else {
          ans[i] = -pow_non_zero;
        }
        pow_non_zero *= 2;
      }
    }
    return std::make_pair(m, ans);
  };
#ifndef GOLIKOV
  for (auto& x : a) {
    cin >> x;
  }
  auto answer = solve(a);
  cout << answer.first << '\n';
  for (auto x : answer.second) {
    cout << x << ' ';
  }
  cout << '\n';
#else
  std::mt19937 rng(566);
  auto rnd = [&](auto from, auto to) {
    return std::uniform_int_distribution<int>(from, to)(rng);
  };
  while (true) {
    int n = rnd(1, 10);
    vector<int> a(n);
    int nonzeros = 0;
    for (int i = 0; i < n; ++i) {
      a[i] = rnd(-1, 1);
      nonzeros += a[i] != 0;
    }
    if (!nonzeros) {
      continue;
    }
    auto result = solve(a);
    auto cnt = check(result.second, result.first);
    if (cnt != 2) {
      cerr << "FOUND\n";
      cerr << cnt << '\n';
      cerr << n << '\n';
      for (auto x : a) {
        cerr << x << ' ';
      }
      cerr << '\n';
      cerr << result.first << '\n';
      for (auto x : result.second) {
        cerr << x << ' ';
      }
      cerr << '\n';
      return 0;
    }
  }
#endif
  return 0;
}
